diff --git a/usr.bin/rfcomm_sppd/rfcomm_sppd.c b/usr.bin/rfcomm_sppd/rfcomm_sppd.c
index 72b02f4e3b..b26880594f 100644
--- a/usr.bin/rfcomm_sppd/rfcomm_sppd.c
+++ b/usr.bin/rfcomm_sppd/rfcomm_sppd.c
@@ -1,37 +1,8 @@
-/* $NetBSD: rfcomm_sppd.c,v 1.8 2007/04/21 10:39:30 dsl Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * rfcomm_sppd.c
- *
- * Copyright (c) 2007 Iain Hibbert
+ */
+
+/*-
  * Copyright (c) 2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
  * All rights reserved.
  *
@@ -55,8 +26,12 @@
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
+ *
+ * $Id: rfcomm_sppd.c,v 1.4 2003/09/07 18:15:55 max Exp $
+ * $FreeBSD: head/usr.bin/bluetooth/rfcomm_sppd/rfcomm_sppd.c 188130 2009-02-04 22:04:06Z emax $
  */
 
+#include <sys/stat.h>
 #include <bluetooth.h>
 #include <ctype.h>
 #include <err.h>
@@ -74,109 +49,85 @@
 #include <syslog.h>
 #include <termios.h>
 #include <unistd.h>
-#include <sys/stat.h>
 
-#include <netbt/rfcomm.h>
-
-#include "rfcomm_sdp.h"
-
-#define max(a, b)	((a) > (b) ? (a) : (b))
-
-int open_tty(const char *);
-int open_client(bdaddr_t *, bdaddr_t *, int, const char *);
-int open_server(bdaddr_t *, uint8_t, int, const char *);
-void copy_data(int, int);
-void sighandler(int);
-void usage(void) __dead2;
-void reset_tio(void);
-
-int done;		/* got a signal */
-struct termios tio;	/* stored termios for reset on exit */
-
-struct service {
-	const char	*name;
-	const char	*description;
-	uint16_t	class;
-	int		pdulen;
-} services[] = {
-	{ "DUN",	"Dialup Networking",
-	  SDP_SERVICE_CLASS_DIALUP_NETWORKING,
-	  sizeof(struct sdp_dun_profile)
-	},
-	{ "LAN",	"Lan access using PPP",
-	  SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP,
-	  sizeof(struct sdp_lan_profile)
-	},
-	{ "SP",		"Serial Port",
-	  SDP_SERVICE_CLASS_SERIAL_PORT,
-	  sizeof(struct sdp_sp_profile)
-	},
-	{ NULL,		NULL,
-	  0,
-	  0
-	}
-};
+#define SPPD_IDENT		"rfcomm_sppd"
+#define SPPD_BUFFER_SIZE	1024
+#define max(a, b)		(((a) > (b))? (a) : (b))
+
+int		rfcomm_channel_lookup	(bdaddr_t const *local,
+					 bdaddr_t const *remote, 
+					 int service, int *channel, int *error);
+
+static int	sppd_ttys_open	(char const *tty, int *amaster, int *aslave);
+static int	sppd_read	(int fd, char *buffer, int size);
+static int	sppd_write	(int fd, char *buffer, int size);
+static void	sppd_sighandler	(int s);
+static void	usage		(void) __dead2;
+
+static int	done;	/* are we done? */
 
+/* Main */
 int
-main(int argc, char *argv[])
+main(int argc, char *argv[]) 
 {
-	struct termios		t;
-	bdaddr_t		laddr, raddr;
-	fd_set			rdset;
-	const char		*service;
-	char			*ep, *tty;
-	int			lm, n, rfcomm, tty_in, tty_out;
-	uint8_t			channel;
-
-	bdaddr_copy(&laddr, BDADDR_ANY);
-	bdaddr_copy(&raddr, BDADDR_ANY);
-	service = "SP";
-	tty = NULL;
-	channel = 0;
-	lm = 0;
+	struct sigaction	 sa;
+	struct sockaddr_rfcomm	 ra;
+	bdaddr_t		 addr;
+	int			 n, background, channel, service,
+				 s, amaster, aslave, fd, doserver;
+	fd_set			 rfd;
+	char			*tty = NULL, *ep = NULL, buf[SPPD_BUFFER_SIZE];
+
+	memcpy(&addr, NG_HCI_BDADDR_ANY, sizeof(addr));
+	background = channel = 0;
+	service = SDP_SERVICE_CLASS_SERIAL_PORT;
+	doserver = 0;
 
 	/* Parse command line options */
-	while ((n = getopt(argc, argv, "a:c:d:hm:s:t:")) != -1) {
-		switch (n) {
-		case 'a': /* remote device address */
-			if (!bt_aton(optarg, &raddr)) {
+	while ((n = getopt(argc, argv, "a:bc:t:hS")) != -1) {
+		switch (n) { 
+		case 'a': /* BDADDR */
+			if (!bt_aton(optarg, &addr)) {
 				struct hostent	*he = NULL;
 
 				if ((he = bt_gethostbyname(optarg)) == NULL)
-					errx(EXIT_FAILURE, "%s: %s", optarg,
-					    hstrerror(h_errno));
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
 
-				bdaddr_copy(&raddr, (bdaddr_t *)he->h_addr);
+				memcpy(&addr, he->h_addr, sizeof(addr));
 			}
 			break;
 
 		case 'c': /* RFCOMM channel */
 			channel = strtoul(optarg, &ep, 10);
-			if (*ep != '\0' || channel < 1 || channel > 30)
-				errx(EXIT_FAILURE, "Invalid channel: %s", optarg);
-
-			break;
-
-		case 'd': /* local device address */
-			if (!bt_devaddr(optarg, &laddr))
-				err(EXIT_FAILURE, "%s", optarg);
-
-			break;
-
-		case 'm': /* Link Mode */
-			if (strcasecmp(optarg, "auth") == 0)
-				lm = RFCOMM_LM_AUTH;
-			else if (strcasecmp(optarg, "encrypt") == 0)
-				lm = RFCOMM_LM_ENCRYPT;
-			else if (strcasecmp(optarg, "secure") == 0)
-				lm = RFCOMM_LM_SECURE;
-			else
-				errx(EXIT_FAILURE, "%s: unknown mode", optarg);
-
+			if (*ep != '\0') {
+				channel = 0;
+				switch (tolower(optarg[0])) {
+				case 'd': /* DialUp Networking */
+					service = SDP_SERVICE_CLASS_DIALUP_NETWORKING;
+					break;
+
+				case 'f': /* Fax */
+					service = SDP_SERVICE_CLASS_FAX;
+					break;
+
+				case 'l': /* LAN */
+					service = SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP;
+					break;
+
+				case 's': /* Serial Port */
+					service = SDP_SERVICE_CLASS_SERIAL_PORT;
+					break;
+
+				default:
+					errx(1, "Unknown service name: %s",
+						optarg);
+					/* NOT REACHED */
+				}
+			}
 			break;
 
-		case 's': /* service class */
-			service = optarg;
+		case 'b': /* Run in background */
+			background = 1;
 			break;
 
 		case 't': /* Slave TTY name */
@@ -184,7 +135,10 @@ main(int argc, char *argv[])
 				asprintf(&tty, "%s%s", _PATH_DEV, optarg);
 			else
 				tty = optarg;
+			break;
 
+		case 'S':
+			doserver = 1;
 			break;
 
 		case 'h':
@@ -194,117 +148,253 @@ main(int argc, char *argv[])
 		}
 	}
 
-	/*
-	 * validate options:
-	 *	must have channel or remote address but not both
-	 */
-	if ((channel == 0 && bdaddr_any(&raddr))
-	    || (channel != 0 && !bdaddr_any(&raddr)))
+	/* Check if we have everything we need */
+	if (!doserver && memcmp(&addr, NG_HCI_BDADDR_ANY, sizeof(addr)) == 0)
 		usage();
+		/* NOT REACHED */
 
-	/*
-	 * grab ttys before we start the bluetooth
-	 */
-	if (tty == NULL) {
-		tty_in = STDIN_FILENO;
-		tty_out = STDOUT_FILENO;
-	} else {
-		tty_in = open_tty(tty);
-		tty_out = tty_in;
-	}
+	/* Set signal handlers */
+	memset(&sa, 0, sizeof(sa));
+	sa.sa_handler = sppd_sighandler;
 
-	/* open RFCOMM */
-	if (channel == 0)
-		rfcomm = open_client(&laddr, &raddr, lm, service);
-	else
-		rfcomm = open_server(&laddr, channel, lm, service);
+	if (sigaction(SIGTERM, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGTERM)");
+ 
+	if (sigaction(SIGHUP, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGHUP)");
+ 
+	if (sigaction(SIGINT, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGINT)");
 
-	/*
-	 * now we are ready to go, so either detach or maybe turn
-	 * off some input processing, so that rfcomm_sppd can
-	 * be used directly with stdio
-	 */
-	if (tty == NULL) {
-		if (tcgetattr(tty_in, &t) < 0)
-			err(EXIT_FAILURE, "tcgetattr");
+	sa.sa_handler = SIG_IGN;
+	sa.sa_flags = SA_NOCLDWAIT;
+
+	if (sigaction(SIGCHLD, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGCHLD)");
 
-		memcpy(&tio, &t, sizeof(tio));
-		t.c_lflag &= ~(ECHO | ICANON);
-		t.c_iflag &= ~(ICRNL);
+	/* Open TTYs */
+	if (tty == NULL) {
+		if (background)
+			usage();
 
-		if (memcmp(&tio, &t, sizeof(tio))) {
-			if (tcsetattr(tty_in, TCSANOW, &t) < 0)
-				err(EXIT_FAILURE, "tcsetattr");
+		amaster = STDIN_FILENO;
+		fd = STDOUT_FILENO;
+	} else {
+		if (sppd_ttys_open(tty, &amaster, &aslave) < 0)
+			exit(1);
+		
+		fd = amaster;
+	}		
+
+	/* Open RFCOMM connection */
+
+	if (doserver) {
+		struct sockaddr_rfcomm	 ma;
+		bdaddr_t		 bt_addr_any;
+		sdp_sp_profile_t	 sp;
+		void			*ss;
+		uint32_t		 sdp_handle;
+		int			 acceptsock, aaddrlen;
+
+		acceptsock = socket(PF_BLUETOOTH, SOCK_STREAM,
+					BLUETOOTH_PROTO_RFCOMM);
+		if (acceptsock < 0)
+			err(1, "Could not create socket");
+
+		memcpy(&bt_addr_any, NG_HCI_BDADDR_ANY, sizeof(bt_addr_any));
+
+		memset(&ma, 0, sizeof(ma));
+		ma.rfcomm_len = sizeof(ma);
+		ma.rfcomm_family = AF_BLUETOOTH;
+		memcpy(&ma.rfcomm_bdaddr, &bt_addr_any, sizeof(bt_addr_any));
+		ma.rfcomm_channel = channel;
+
+		if (bind(acceptsock, (struct sockaddr *)&ma, sizeof(ma)) < 0)
+			err(1, "Could not bind socket on channel %d", channel);
+		if (listen(acceptsock, 10) != 0)
+			err(1, "Could not listen on socket");
+
+		aaddrlen = sizeof(ma);
+		if (getsockname(acceptsock, (struct sockaddr *)&ma, &aaddrlen) < 0)
+			err(1, "Could not get socket name");
+		channel = ma.rfcomm_channel;
+
+		ss = sdp_open_local(NULL);
+		if (ss == NULL)
+			errx(1, "Unable to create local SDP session");
+		if (sdp_error(ss) != 0)
+			errx(1, "Unable to open local SDP session. %s (%d)",
+			    strerror(sdp_error(ss)), sdp_error(ss));
+		memset(&sp, 0, sizeof(sp));
+		sp.server_channel = channel;
+
+		if (sdp_register_service(ss, SDP_SERVICE_CLASS_SERIAL_PORT,
+				&bt_addr_any, (void *)&sp, sizeof(sp),
+				&sdp_handle) != 0) {
+			errx(1, "Unable to register LAN service with "
+			    "local SDP daemon. %s (%d)",
+			    strerror(sdp_error(ss)), sdp_error(ss));
+		}
 
-			atexit(reset_tio);
+		s = -1;
+		while (s < 0) {
+			aaddrlen = sizeof(ra);
+			s = accept(acceptsock, (struct sockaddr *)&ra,
+			    &aaddrlen);
+			if (s < 0)
+				err(1, "Unable to accept()");
+			if (memcmp(&addr, NG_HCI_BDADDR_ANY, sizeof(addr)) &&
+			    memcmp(&addr, &ra.rfcomm_bdaddr, sizeof(addr))) {
+				warnx("Connect from wrong client");
+				close(s);
+				s = -1;
+			}
 		}
+		sdp_unregister_service(ss, sdp_handle);
+		sdp_close(ss);
+		close(acceptsock);
 	} else {
-		if (daemon(0, 0) < 0)
-			err(EXIT_FAILURE, "daemon() failed");
+		/* Check channel, if was not set then obtain it via SDP */
+		if (channel == 0 && service != 0)
+			if (rfcomm_channel_lookup(NULL, &addr,
+				    service, &channel, &n) != 0)
+				errc(1, n, "Could not obtain RFCOMM channel");
+		if (channel <= 0 || channel > 30)
+			errx(1, "Invalid RFCOMM channel number %d", channel);
+
+		s = socket(PF_BLUETOOTH, SOCK_STREAM, BLUETOOTH_PROTO_RFCOMM);
+		if (s < 0)
+			err(1, "Could not create socket");
+
+		memset(&ra, 0, sizeof(ra));
+		ra.rfcomm_len = sizeof(ra);
+		ra.rfcomm_family = AF_BLUETOOTH;
+
+		if (bind(s, (struct sockaddr *) &ra, sizeof(ra)) < 0)
+			err(1, "Could not bind socket");
+
+		memcpy(&ra.rfcomm_bdaddr, &addr, sizeof(ra.rfcomm_bdaddr));
+		ra.rfcomm_channel = channel;
+
+		if (connect(s, (struct sockaddr *) &ra, sizeof(ra)) < 0)
+			err(1, "Could not connect socket");
 	}
 
-	/* catch signals */
-	done = 0;
-	(void)signal(SIGHUP, sighandler);
-	(void)signal(SIGINT, sighandler);
-	(void)signal(SIGPIPE, sighandler);
-	(void)signal(SIGTERM, sighandler);
+	/* Became daemon if required */
+	if (background && daemon(0, 0) < 0)
+		err(1, "Could not daemon()");
 
-	openlog(getprogname(), LOG_PERROR | LOG_PID, LOG_DAEMON);
-	syslog(LOG_INFO, "Starting on %s...", (tty ? tty : "stdio"));
+	openlog(SPPD_IDENT, LOG_NDELAY|LOG_PERROR|LOG_PID, LOG_DAEMON);
+	syslog(LOG_INFO, "Starting on %s...", (tty != NULL)? tty : "stdin/stdout");
 
-	n = max(tty_in, rfcomm) + 1;
-	while (!done) {
-		FD_ZERO(&rdset);
-		FD_SET(tty_in, &rdset);
-		FD_SET(rfcomm, &rdset);
+	for (done = 0; !done; ) {
+		FD_ZERO(&rfd);
+		FD_SET(amaster, &rfd);
+		FD_SET(s, &rfd);
 
-		if (select(n, &rdset, NULL, NULL, NULL) < 0) {
+		n = select(max(amaster, s) + 1, &rfd, NULL, NULL, NULL);
+		if (n < 0) {
 			if (errno == EINTR)
 				continue;
 
-			syslog(LOG_ERR, "select error: %m");
-			exit(EXIT_FAILURE);
+			syslog(LOG_ERR, "Could not select(). %s",
+					strerror(errno));
+			exit(1);
+		}
+
+		if (n == 0)
+			continue;
+
+		if (FD_ISSET(amaster, &rfd)) {
+			n = sppd_read(amaster, buf, sizeof(buf));
+			if (n < 0) {
+				syslog(LOG_ERR, "Could not read master pty, " \
+					"fd=%d. %s", amaster, strerror(errno));
+				exit(1);
+			}
+
+			if (n == 0)
+				break; /* XXX */
+
+			if (sppd_write(s, buf, n) < 0) {
+				syslog(LOG_ERR, "Could not write to socket, " \
+					"fd=%d, size=%d. %s",
+					s, n, strerror(errno));
+				exit(1);
+			}
 		}
 
-		if (FD_ISSET(tty_in, &rdset))
-			copy_data(tty_in, rfcomm);
+		if (FD_ISSET(s, &rfd)) {
+			n = sppd_read(s, buf, sizeof(buf));
+			if (n < 0) {
+				syslog(LOG_ERR, "Could not read socket, " \
+					"fd=%d. %s", s, strerror(errno));
+				exit(1);
+			}
+
+			if (n == 0)
+				break;
 
-		if (FD_ISSET(rfcomm, &rdset))
-			copy_data(rfcomm, tty_out);
+			if (sppd_write(fd, buf, n) < 0) {
+				syslog(LOG_ERR, "Could not write to master " \
+					"pty, fd=%d, size=%d. %s",
+					fd, n, strerror(errno));
+				exit(1);
+			}
+		}
 	}
 
-	syslog(LOG_INFO, "Completed on %s", (tty ? tty : "stdio"));
-	exit(EXIT_SUCCESS);
+	syslog(LOG_INFO, "Completed on %s", (tty != NULL)? tty : "stdin/stdout");
+	closelog();
+
+	close(s);
+
+	if (tty != NULL) {
+		close(aslave);
+		close(amaster);
+	}	
+
+	return (0);
 }
 
-int
-open_tty(const char *tty)
+/* Open TTYs */
+static int
+sppd_ttys_open(char const *tty, int *amaster, int *aslave)
 {
 	char		 pty[PATH_MAX], *slash;
 	struct group	*gr = NULL;
 	gid_t		 ttygid;
-	int		 master;
+	struct termios	 tio;
 
 	/*
 	 * Construct master PTY name. The slave tty name must be less then
-	 * PATH_MAX characters in length, must contain '/' character and
+	 * PATH_MAX characters in length, must contain '/' character and 
 	 * must not end with '/'.
 	 */
-	if (strlen(tty) >= sizeof(pty))
-		errx(EXIT_FAILURE, ": tty name too long");
+
+	if (strlen(tty) >= sizeof(pty)) {
+		syslog(LOG_ERR, "Slave tty name is too long");
+		return (-1);
+	}
 
 	strlcpy(pty, tty, sizeof(pty));
 	slash = strrchr(pty, '/');
-	if (slash == NULL || slash[1] == '\0')
-		errx(EXIT_FAILURE, "%s: invalid tty", tty);
+	if (slash == NULL || slash[1] == '\0') {
+		syslog(LOG_ERR, "Invalid slave tty name (%s)", tty);
+		return (-1);
+	}
 
 	slash[1] = 'p';
-	if (strcmp(pty, tty) == 0)
-		errx(EXIT_FAILURE, "Master and slave tty are the same (%s)", tty);
+	
+	if (strcmp(pty, tty) == 0) {
+		syslog(LOG_ERR, "Master and slave tty are the same (%s)", tty);
+		return (-1);
+	}
 
-	if ((master = open(pty, O_RDWR, 0)) < 0)
-		err(EXIT_FAILURE, "%s", pty);
+	if ((*amaster = open(pty, O_RDWR, 0)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s", pty, strerror(errno));
+		return (-1);
+	}
 
 	/*
 	 * Slave TTY
@@ -313,207 +403,102 @@ open_tty(const char *tty)
 	if ((gr = getgrnam("tty")) != NULL)
 		ttygid = gr->gr_gid;
 	else
-		ttygid = (gid_t)-1;
-
-	(void)chown(tty, getuid(), ttygid);
-	(void)chmod(tty, S_IRUSR | S_IWUSR | S_IWGRP);
-	(void)revoke(tty);
-
-	return master;
-}
-
-int
-open_client(bdaddr_t *laddr, bdaddr_t *raddr, int lm, const char *service)
-{
-	struct sockaddr_bt sa;
-	struct service *s;
-	struct linger l;
-	char *ep;
-	int fd;
-	uint8_t channel = 0;	/* avoid gcc warnings */
-
-	for (s = services ; ; s++) {
-		if (s->name == NULL) {
-			channel = strtoul(service, &ep, 10);
-			if (*ep != '\0' || channel < 1 || channel > 30)
-				errx(EXIT_FAILURE, "Invalid service: %s", service);
-
-			break;
-		}
+		ttygid = -1;
 
-		if (strcasecmp(s->name, service) == 0) {
-			if (rfcomm_channel_lookup(laddr, raddr, s->class, &channel, &errno) < 0)
-				err(EXIT_FAILURE, "%s", s->name);
+	(void) chown(tty, getuid(), ttygid);
+	(void) chmod(tty, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP);
+	(void) revoke(tty);
 
-			break;
-		}
+	if ((*aslave = open(tty, O_RDWR, 0)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s", tty, strerror(errno));
+		close(*amaster);
+		return (-1);
 	}
 
-	memset(&sa, 0, sizeof(sa));
-	sa.bt_len = sizeof(sa);
-	sa.bt_family = AF_BLUETOOTH;
-	bdaddr_copy(&sa.bt_bdaddr, laddr);
-
-	fd = socket(PF_BLUETOOTH, SOCK_STREAM, BTPROTO_RFCOMM);
-	if (fd < 0)
-		err(EXIT_FAILURE, "socket()");
-
-	if (bind(fd, (struct sockaddr *)&sa, sizeof(sa)) < 0)
-		err(EXIT_FAILURE, "bind(%s)", bt_ntoa(laddr, NULL));
-
-	memset(&l, 0, sizeof(l));
-	l.l_onoff = 1;
-	l.l_linger = 5;
-	if (setsockopt(fd, SOL_SOCKET, SO_LINGER, &l, sizeof(l)) < 0)
-		err(EXIT_FAILURE, "linger()");
-
-	if (setsockopt(fd, BTPROTO_RFCOMM, SO_RFCOMM_LM, &lm, sizeof(lm)) < 0)
-		err(EXIT_FAILURE, "link mode");
-
-	sa.bt_channel = channel;
-	bdaddr_copy(&sa.bt_bdaddr, raddr);
+	/*
+	 * Make slave TTY raw
+	 */
 
-	if (connect(fd, (struct sockaddr *)&sa, sizeof(sa)) < 0)
-		err(EXIT_FAILURE, "connect(%s, %d)", bt_ntoa(raddr, NULL),
-						     channel);
+	cfmakeraw(&tio);
 
-	return fd;
-}
+	if (tcsetattr(*aslave, TCSANOW, &tio) < 0) {
+		syslog(LOG_ERR, "Could not tcsetattr(). %s", strerror(errno));
+		close(*aslave);
+		close(*amaster);
+		return (-1);
+	}
 
-/*
- * In all the profiles we currently support registering, the channel
- * is the first octet in the PDU, and it seems all the rest can be
- * zero, so we just use an array of uint8_t big enough to store the
- * largest, currently LAN. See <sdp.h> for definitions..
- */
-#define pdu_len		sizeof(struct sdp_lan_profile)
+	return (0);
+} /* sppd_ttys_open */
 
-int
-open_server(bdaddr_t *laddr, uint8_t channel, int lm, const char *service)
+/* Read data */
+static int
+sppd_read(int fd, char *buffer, int size)
 {
-	struct sockaddr_bt sa;
-	struct linger l;
-	socklen_t len;
-	void *ss;
-	int sv, fd, n;
-	uint8_t pdu[pdu_len];
-
-	memset(&sa, 0, sizeof(sa));
-	sa.bt_len = sizeof(sa);
-	sa.bt_family = AF_BLUETOOTH;
-	bdaddr_copy(&sa.bt_bdaddr, laddr);
-	sa.bt_channel = channel;
-
-	sv = socket(PF_BLUETOOTH, SOCK_STREAM, BTPROTO_RFCOMM);
-	if (sv < 0)
-		err(EXIT_FAILURE, "socket()");
-
-	if (bind(sv, (struct sockaddr *)&sa, sizeof(sa)) < 0)
-		err(EXIT_FAILURE, "bind(%s, %d)", bt_ntoa(laddr, NULL),
-						  channel);
-
-	if (setsockopt(sv, BTPROTO_RFCOMM, SO_RFCOMM_LM, &lm, sizeof(lm)) < 0)
-		err(EXIT_FAILURE, "link mode");
-
-	if (listen(sv, 1) < 0)
-		err(EXIT_FAILURE, "listen()");
-
-	/* Register service with SDP server */
-	for (n = 0 ; ; n++) {
-		if (services[n].name == NULL)
-			usage();
-
-		if (strcasecmp(services[n].name, service) == 0)
-			break;
-	}
+	int	n;
 
-	memset(pdu, 0, pdu_len);
-	pdu[0] = channel;
+again:
+	n = read(fd, buffer, size);
+	if (n < 0) {
+		if (errno == EINTR)
+			goto again;
 
-	ss = sdp_open_local(NULL);
-	if (ss == NULL || (errno = sdp_error(ss)) != 0)
-		err(EXIT_FAILURE, "sdp_open_local");
-
-	if (sdp_register_service(ss, services[n].class, laddr,
-		    pdu, services[n].pdulen, NULL) != 0) {
-		errno = sdp_error(ss);
-		err(EXIT_FAILURE, "sdp_register_service");
+		return (-1);
 	}
 
-	len = sizeof(sa);
-	fd = accept(sv, (struct sockaddr *)&sa, &len);
-	if (fd < 0)
-		err(EXIT_FAILURE, "accept");
-
-	memset(&l, 0, sizeof(l));
-	l.l_onoff = 1;
-	l.l_linger = 5;
-	if (setsockopt(fd, SOL_SOCKET, SO_LINGER, &l, sizeof(l)) < 0)
-		err(EXIT_FAILURE, "linger()");
-
-	close(sv);
-	return fd;
-}
+	return (n);
+} /* sppd_read */
 
-void
-copy_data(int src, int dst)
+/* Write data */
+static int
+sppd_write(int fd, char *buffer, int size)
 {
-	static char	buf[BUFSIZ];
-	ssize_t		nr, nw, off;
+	int	n, wrote;
 
-	while ((nr = read(src, buf, sizeof(buf))) == -1) {
-		if (errno != EINTR) {
-			syslog(LOG_ERR, "read failed: %m");
-			exit(EXIT_FAILURE);
-		}
-	}
+	for (wrote = 0; size > 0; ) {
+		n = write(fd, buffer, size);
+		switch (n) {
+		case -1:
+			if (errno != EINTR)
+				return (-1);
+			break;
 
-	if (nr == 0)	/* reached EOF */
-		done++;
+		case 0: 
+			/* XXX can happen? */
+			break;
 
-	for (off = 0 ; nr ; nr -= nw, off += nw) {
-		if ((nw = write(dst, buf + off, (size_t)nr)) == -1) {
-			syslog(LOG_ERR, "write failed: %m");
-			exit(EXIT_FAILURE);
+		default:
+			wrote += n;
+			buffer += n;
+			size -= n;
+			break;
 		}
 	}
-}
 
-void
-sighandler(int s __unused)
-{
-
-	done++;
-}
+	return (wrote);
+} /* sppd_write */
 
-void
-reset_tio(void)
+/* Signal handler */
+static void
+sppd_sighandler(int s)
 {
-
-	tcsetattr(STDIN_FILENO, TCSAFLUSH, &tio);
-}
-
-void
+	syslog(LOG_INFO, "Signal %d received. Total %d signals received\n",
+			s, ++ done);
+} /* sppd_sighandler */
+ 
+/* Display usage and exit */
+static void
 usage(void)
 {
-	const char *cmd = getprogname();
-	struct service *s;
-
-	fprintf(stderr, "Usage: %s [-d device] [-m mode] [-s service] [-t tty]\n"
-			"       %*s {-a bdaddr | -c channel}\n"
-			"\n"
-			"Where:\n"
-			"\t-a bdaddr    remote device address\n"
-			"\t-c channel   local RFCOMM channel\n"
-			"\t-d device    local device address\n"
-			"\t-m mode      link mode\n"
-			"\t-s service   service class\n"
-			"\t-t tty       run in background using pty\n"
-			"\n", cmd, (int)strlen(cmd), "");
-
-	fprintf(stderr, "Known service classes:\n");
-	for (s = services ; s->name != NULL ; s++)
-		fprintf(stderr, "\t%-13s%s\n", s->name, s->description);
-
-	exit(EXIT_FAILURE);
-}
+	fprintf(stdout,
+"Usage: %s options\n" \
+"Where options are:\n" \
+"\t-a address Peer address (required in client mode)\n" \
+"\t-b         Run in background\n" \
+"\t-c channel RFCOMM channel to connect to or listen on\n" \
+"\t-t tty     TTY name (required in background mode)\n" \
+"\t-S         Server mode\n" \
+"\t-h         Display this message\n", SPPD_IDENT);
+	exit(255);
+} /* usage */
+
diff --git a/usr.sbin/Makefile b/usr.sbin/Makefile
index 5c5c7bce00..7a82792185 100644
--- a/usr.sbin/Makefile
+++ b/usr.sbin/Makefile
@@ -1,5 +1,7 @@
 #	From: @(#)Makefile	5.20 (Berkeley) 6/12/93
 # $FreeBSD: src/usr.sbin/Makefile,v 1.183.2.14 2003/04/16 11:01:51 ru Exp $
+#
+# XXX MISSING: bthidd btpand
 
 .include "../sys/platform/${MACHINE_PLATFORM}/Makefile.inc"
 
@@ -10,12 +12,14 @@ SUBDIR= 802_11 \
 	adduser \
 	arp \
 	asf \
+	ath3kfw \
 	authpf \
 	autofs \
+	bcmfw \
 	boot0cfg \
 	bootparamd \
-	btconfig \
-	bthcid \
+	bt3cfw \
+	bthidcontrol \
 	burncd \
 	cdcontrol \
 	chkgrp \
@@ -42,6 +46,9 @@ SUBDIR= 802_11 \
 	ftp-proxy \
 	fwcontrol \
 	gifconfig \
+	hccontrol \
+	hcsecd \
+	hcseriald \
 	hotplugd \
 	ifmcstat \
 	inetd \
@@ -54,6 +61,8 @@ SUBDIR= 802_11 \
 	kbdmap \
 	keyserv \
 	lastlogin \
+	l2control \
+	l2ping \
 	mailwrapper \
 	makefs \
 	manctl \
@@ -90,6 +99,7 @@ SUBDIR= 802_11 \
 	rarpd \
 	repquota \
 	resident \
+	rfcomm_pppd \
 	rip6query \
 	rmt \
 	route6d \
@@ -107,6 +117,7 @@ SUBDIR= 802_11 \
 	rtsold \
 	rwhod \
 	sa \
+	sdpcontrol \
 	sdpd \
 	sensorsd \
 	service \
diff --git a/usr.sbin/ath3kfw/Makefile b/usr.sbin/ath3kfw/Makefile
new file mode 100644
index 0000000000..c509671c0d
--- /dev/null
+++ b/usr.sbin/ath3kfw/Makefile
@@ -0,0 +1,8 @@
+# $FreeBSD: head/usr.sbin/bluetooth/ath3kfw/Makefile 222772 2011-06-06 20:24:17Z ed $
+
+PROG=		ath3kfw
+MAN=		ath3kfw.8
+DPADD+=		${LIBUSB}
+LDADD+=		-lusb
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/ath3kfw/ath3kfw.c b/usr.sbin/ath3kfw/ath3kfw.c
new file mode 100644
index 0000000000..9e1d5fd755
--- /dev/null
+++ b/usr.sbin/ath3kfw/ath3kfw.c
@@ -0,0 +1,297 @@
+/*
+ * ath3kfw.c
+ */
+
+/*-
+ * Copyright (c) 2010 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: head/usr.sbin/bluetooth/ath3kfw/ath3kfw.c 249179 2013-04-05 23:42:22Z adrian $
+ */
+
+#include <sys/types.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <libusb20_desc.h>
+#include <libusb20.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+
+#define ATH3KFW			"ath3kfw"
+#define ATH3KFW_VENDOR_ID	0x0cf3
+#define ATH3KFW_PRODUCT_ID	0x3000
+#define ATH3KFW_FW		"/usr/local/etc/ath3k-1.fw"
+#define ATH3KFW_BULK_EP		0x02
+#define	ATH3KFW_REQ_DFU_DNLOAD	1
+#define	ATH3KFW_MAX_BSIZE	4096
+
+static int	parse_ugen_name		(char const *ugen, uint8_t *bus,
+					 uint8_t *addr);
+static int	find_device		(struct libusb20_backend *be,
+					 uint8_t bus, uint8_t addr,
+					 struct libusb20_device **dev);
+static int	download_firmware	(struct libusb20_device *dev,
+					 char const *firmware);
+static void	usage			(void);
+
+static int			vendor_id = ATH3KFW_VENDOR_ID;
+static int			product_id = ATH3KFW_PRODUCT_ID;
+
+/*
+ * Firmware downloader for Atheros AR3011 based USB Bluetooth devices
+ */
+
+int
+main(int argc, char **argv)
+{
+	uint8_t			bus, addr;
+	char const		*firmware;
+	struct libusb20_backend	*be;
+	struct libusb20_device	*dev;
+	int			n;
+
+	openlog(ATH3KFW, LOG_NDELAY|LOG_PERROR|LOG_PID, LOG_USER);
+
+	bus = 0;
+	addr = 0;
+	firmware = ATH3KFW_FW;
+
+	while ((n = getopt(argc, argv, "d:f:hp:v:")) != -1) {
+		switch (n) {
+		case 'd': /* ugen device name */
+			if (parse_ugen_name(optarg, &bus, &addr) < 0)
+				usage();
+			break;
+
+		case 'f': /* firmware file */
+			firmware = optarg;
+			break;
+		case 'p': /* product id */
+			product_id = strtol(optarg, NULL, 0);
+			break;
+		case 'v': /* vendor id */
+			vendor_id = strtol(optarg, NULL, 0);
+			break;
+		case 'h':
+		default:
+			usage();
+			break;
+			/* NOT REACHED */
+		}
+	}
+
+	be = libusb20_be_alloc_default();
+	if (be == NULL) {
+		syslog(LOG_ERR, "libusb20_be_alloc_default() failed");
+		return (-1);
+	}
+
+	if (find_device(be, bus, addr, &dev) < 0) {
+		syslog(LOG_ERR, "ugen%d.%d is not recognized as " \
+			"Atheros AR3011 based device " \
+			"(possibly caused by lack of permissions)", bus, addr);
+		return (-1);
+	}
+
+	if (download_firmware(dev, firmware) < 0) {
+		syslog(LOG_ERR, "could not download %s firmare to ugen%d.%d",
+			firmware, bus, addr);
+		return (-1);
+	}
+
+	libusb20_be_free(be);
+	closelog();
+	
+	return (0);
+}
+
+/*
+ * Parse ugen name and extract device's bus and address
+ */
+
+static int
+parse_ugen_name(char const *ugen, uint8_t *bus, uint8_t *addr)
+{
+	char	*ep;
+
+	if (strncmp(ugen, "ugen", 4) != 0)
+		return (-1);
+
+	*bus = (uint8_t) strtoul(ugen + 4, &ep, 10);
+	if (*ep != '.')
+		return (-1);
+
+	*addr = (uint8_t) strtoul(ep + 1, &ep, 10);
+	if (*ep != '\0')
+		return (-1);
+
+	return (0);
+}
+
+/*
+ * Find USB device
+ */
+
+static int
+find_device(struct libusb20_backend *be, uint8_t bus, uint8_t addr,
+		struct libusb20_device **dev)
+{
+	struct LIBUSB20_DEVICE_DESC_DECODED	*desc;
+
+	*dev = NULL;
+
+	while ((*dev = libusb20_be_device_foreach(be, *dev)) != NULL) {
+		if (libusb20_dev_get_bus_number(*dev) != bus ||
+		    libusb20_dev_get_address(*dev) != addr)
+			continue;
+
+		desc = libusb20_dev_get_device_desc(*dev);
+		if (desc == NULL)
+			continue;
+
+		if (desc->idVendor != vendor_id ||
+		    desc->idProduct != product_id)
+			continue;
+
+		break;
+	}
+
+	return ((*dev == NULL)? -1 : 0);
+}
+
+/*
+ * Download firmware
+ */
+
+static int
+download_firmware(struct libusb20_device *dev, char const *firmware)
+{
+	struct libusb20_transfer		*bulk;
+	struct LIBUSB20_CONTROL_SETUP_DECODED	req;
+	int					fd, n, error;
+	uint8_t					buf[ATH3KFW_MAX_BSIZE];
+
+	error = -1;
+
+	if (libusb20_dev_open(dev, 1) != 0) {
+		syslog(LOG_ERR, "libusb20_dev_open() failed");
+		return (error);
+	}
+
+	if ((bulk = libusb20_tr_get_pointer(dev, 0)) == NULL) {
+		syslog(LOG_ERR, "libusb20_tr_get_pointer() failed");
+		goto out;
+	}
+
+	if (libusb20_tr_open(bulk, ATH3KFW_MAX_BSIZE, 1, ATH3KFW_BULK_EP) != 0) {
+		syslog(LOG_ERR, "libusb20_tr_open(%d, 1, %d) failed",
+			ATH3KFW_MAX_BSIZE, ATH3KFW_BULK_EP);
+		goto out;
+	}
+
+	if ((fd = open(firmware, O_RDONLY)) < 0) {
+		syslog(LOG_ERR, "open(%s) failed. %s",
+			firmware, strerror(errno));
+		goto out1;
+	}
+
+	n = read(fd, buf, 20);
+	if (n != 20) {
+		syslog(LOG_ERR, "read(%s, 20) failed. %s",
+			firmware, strerror(errno));
+		goto out2;
+	}
+
+	LIBUSB20_INIT(LIBUSB20_CONTROL_SETUP, &req);
+	req.bmRequestType = LIBUSB20_REQUEST_TYPE_VENDOR;
+	req.bRequest = ATH3KFW_REQ_DFU_DNLOAD;
+	req.wLength = 20;
+
+	if (libusb20_dev_request_sync(dev, &req, buf, NULL, 5000, 0) != 0) {
+		syslog(LOG_ERR, "libusb20_dev_request_sync() failed");
+		goto out2;
+	}
+
+	for (;;) {
+		n = read(fd, buf, sizeof(buf));
+		if (n < 0) {
+			syslog(LOG_ERR, "read(%s, %d) failed. %s",
+				firmware, (int) sizeof(buf), strerror(errno));
+			goto out2;
+		}
+		if (n == 0)
+			break;
+
+		libusb20_tr_setup_bulk(bulk, buf, n, 3000);
+		libusb20_tr_start(bulk);
+
+		while (libusb20_dev_process(dev) == 0) {
+			if (libusb20_tr_pending(bulk) == 0)
+				break;
+
+			libusb20_dev_wait_process(dev, -1);
+		}
+
+		if (libusb20_tr_get_status(bulk) != 0) {
+			syslog(LOG_ERR, "bulk transfer failed with status %d",
+				libusb20_tr_get_status(bulk));
+			goto out2;
+		}
+	}
+
+	error = 0;
+out2:
+	close(fd);
+out1:
+	libusb20_tr_close(bulk);
+out:
+	libusb20_dev_close(dev);
+
+	return (error);
+}
+
+/*
+ * Display usage and exit
+ */
+
+static void
+usage(void)
+{
+	printf(
+"Usage: %s -d ugenX.Y -f firmware_file\n"
+"Usage: %s -h\n" \
+"Where:\n" \
+"\t-d ugenX.Y           ugen device name\n" \
+"\t-f firmware image    firmware image file name for download\n" \
+"\t-v vendor_id         vendor id\n" \
+"\t-p vendor_id         product id\n" \
+"\t-h                   display this message\n", ATH3KFW, ATH3KFW);
+
+        exit(255);
+}
+
diff --git a/usr.sbin/bcmfw/Makefile b/usr.sbin/bcmfw/Makefile
new file mode 100644
index 0000000000..1bdc531000
--- /dev/null
+++ b/usr.sbin/bcmfw/Makefile
@@ -0,0 +1,8 @@
+# $Id: Makefile,v 1.6 2003/08/14 20:05:58 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/bcmfw/Makefile 140941 2005-01-28 16:08:11Z ru $
+
+PROG=		bcmfw
+MAN=		bcmfw.8
+WARNS?=		2
+
+.include <bsd.prog.mk>
